<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>FollowerRequestProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">FollowerRequestProcessor.java</span></div><h1>FollowerRequestProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.util.concurrent.LinkedBlockingQueue;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.ZooKeeperCriticalThread;
import org.apache.zookeeper.server.ZooTrace;

/**
 * This RequestProcessor forwards any requests that modify the state of the
 * system to the Leader.
 */
public class FollowerRequestProcessor extends ZooKeeperCriticalThread implements
        RequestProcessor {
<span class="fc" id="L38">    private static final Logger LOG = LoggerFactory.getLogger(FollowerRequestProcessor.class);</span>

    FollowerZooKeeperServer zks;

    RequestProcessor nextProcessor;

<span class="fc" id="L44">    LinkedBlockingQueue&lt;Request&gt; queuedRequests = new LinkedBlockingQueue&lt;Request&gt;();</span>

<span class="fc" id="L46">    boolean finished = false;</span>

    public FollowerRequestProcessor(FollowerZooKeeperServer zks,
            RequestProcessor nextProcessor) {
<span class="fc" id="L50">        super(&quot;FollowerRequestProcessor:&quot; + zks.getServerId(), zks</span>
<span class="fc" id="L51">                .getZooKeeperServerListener());</span>
<span class="fc" id="L52">        this.zks = zks;</span>
<span class="fc" id="L53">        this.nextProcessor = nextProcessor;</span>
<span class="fc" id="L54">    }</span>

    @Override
    public void run() {
        try {
<span class="pc bpc" id="L59" title="1 of 2 branches missed.">            while (!finished) {</span>
<span class="fc" id="L60">                Request request = queuedRequests.take();</span>
<span class="pc bpc" id="L61" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L62">                    ZooTrace.logRequest(LOG, ZooTrace.CLIENT_REQUEST_TRACE_MASK,</span>
                            'F', request, &quot;&quot;);
                }
<span class="fc bfc" id="L65" title="All 2 branches covered.">                if (request == Request.requestOfDeath) {</span>
<span class="fc" id="L66">                    break;</span>
                }
                // We want to queue the request to be processed before we submit
                // the request to the leader so that we are ready to receive
                // the response
<span class="fc" id="L71">                nextProcessor.processRequest(request);</span>
                
                // We now ship the request to the leader. As with all
                // other quorum operations, sync also follows this code
                // path, but different from others, we need to keep track
                // of the sync operations this follower has pending, so we
                // add it to pendingSyncs.
<span class="fc bfc" id="L78" title="All 3 branches covered.">                switch (request.type) {</span>
                case OpCode.sync:
<span class="fc" id="L80">                    zks.pendingSyncs.add(request);</span>
<span class="fc" id="L81">                    zks.getFollower().request(request);</span>
<span class="fc" id="L82">                    break;</span>
                case OpCode.create:
                case OpCode.delete:
                case OpCode.setData:
                case OpCode.setACL:
                case OpCode.createSession:
                case OpCode.closeSession:
                case OpCode.multi:
<span class="fc" id="L90">                    zks.getFollower().request(request);</span>
                    break;
                }
<span class="fc" id="L93">            }</span>
<span class="fc" id="L94">        } catch (Exception e) {</span>
<span class="fc" id="L95">            handleException(this.getName(), e);</span>
<span class="fc" id="L96">        }</span>
<span class="fc" id="L97">        LOG.info(&quot;FollowerRequestProcessor exited loop!&quot;);</span>
<span class="fc" id="L98">    }</span>

    public void processRequest(Request request) {
<span class="pc bpc" id="L101" title="1 of 2 branches missed.">        if (!finished) {</span>
<span class="fc" id="L102">            queuedRequests.add(request);</span>
        }
<span class="fc" id="L104">    }</span>

    public void shutdown() {
<span class="fc" id="L107">        LOG.info(&quot;Shutting down&quot;);</span>
<span class="fc" id="L108">        finished = true;</span>
<span class="fc" id="L109">        queuedRequests.clear();</span>
<span class="fc" id="L110">        queuedRequests.add(Request.requestOfDeath);</span>
<span class="fc" id="L111">        nextProcessor.shutdown();</span>
<span class="fc" id="L112">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>